/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.lib.basic.viewers.HapticViewer3D.gui.haptics.forces_panels;

import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import javax.swing.ComboBoxModel;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JList;
import javax.swing.JOptionPane;
import org.visnow.vn.lib.basic.viewers.HapticViewer3D.model.InputFields;
import org.visnow.vn.lib.basic.viewers.HapticViewer3D.model.RegularFld_DA;
import org.visnow.vn.lib.basic.viewers.HapticViewer3D.gui.JListClickHelper;
import org.visnow.vn.lib.basic.viewers.HapticViewer3D.model.haptic_forces.forces.DampingField;
import org.visnow.vn.lib.basic.viewers.HapticViewer3D.model.haptic_forces.forces.DampingField.Algorithm;
import org.visnow.vn.lib.basic.viewers.HapticViewer3D.model.haptic_forces.forces.IForce;

/**
 *
 * @author Krzysztof Madejski <krzysztof@madejscy.pl> ICM, University of Warsaw
 * @author modified by Łukasz Czerwiński <czerwinskilukasz1 [#] gmail.com>, ICM, University of
 * Warsaw, 2013
 */
public class EditDampingFieldPanel extends AbstractEditPanel
{

    private DampingField dampingField;
    private final InputFields fields;

    public EditDampingFieldPanel(DampingField dampingField, InputFields fields)
    {
        this.fields = fields;
        initComponents();

        //TODO: duplicated code with EditVectorFieldPanel
        this.dampingField = dampingField;
        dataCB.setSelectedIndex(dampingField.getDataComponentIndex());

        forceScaleTF.setText("" + dampingField.getForceScale());
        jDampingAlgCB.setSelectedIndex(dampingField.getAlgorithm().ordinal());

        /* mouse listener - user can click twice on name of the force instead of selecting it 
         * and clicking Add */
        dataCB.addMouseListener(new MouseAdapter()
        {
            @Override
            public void mouseClicked(MouseEvent evt)
            {

                if (evt.getButton() == MouseEvent.BUTTON1 &&
                    evt.getClickCount() == 2) { // left double click - go Next

                    JList list = (JList) evt.getSource();

                    int index = JListClickHelper.getClickedLocation(list, evt.getPoint()); //could not be locationToIndex(evt.getPoint()), see comment in getClickedLocation
                    if (index >= 0) {
                        list.setSelectedIndex(index);
                        _okButtonActionPerformed();
                    }
                }
            }
        });
    }

    private ComboBoxModel createComboBoxModel()
    {
        return new DefaultComboBoxModel(fields.getScalarFields().toArray());
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        okButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        dataCB = new javax.swing.JList();
        jLabel3 = new javax.swing.JLabel();
        forceScaleTF = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        jDampingAlgCB = new javax.swing.JComboBox();

        jLabel1.setText("Data component:");

        okButton.setText("OK");
        okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okButtonActionPerformed(evt);
            }
        });

        cancelButton.setText("Cancel");
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        dataCB.setModel(createComboBoxModel());
        jScrollPane1.setViewportView(dataCB);

        jLabel3.setText("Force scale:");

        forceScaleTF.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                forceScaleTFaddButtonActionPerformed(evt);
            }
        });

        jLabel4.setText("Type:");

        jDampingAlgCB.setModel(createDampingAlgCBModel());

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
                layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGroup(layout.createSequentialGroup()
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                        .addGroup(layout.createSequentialGroup()
                                                .addGap(10, 10, 10)
                                                .addComponent(jLabel1)
                                                .addGap(6, 6, 6)
                                                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 0, Short.MAX_VALUE))
                                        .addGroup(layout.createSequentialGroup()
                                                .addGap(23, 23, 23)
                                                .addComponent(okButton, javax.swing.GroupLayout.PREFERRED_SIZE, 83, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                .addGap(6, 6, 6)
                                                .addComponent(cancelButton, javax.swing.GroupLayout.PREFERRED_SIZE, 95, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                .addGap(0, 70, Short.MAX_VALUE))
                                        .addGroup(layout.createSequentialGroup()
                                                .addGap(6, 6, 6)
                                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                                        .addComponent(jLabel3)
                                                        .addComponent(jLabel4))
                                                .addGap(35, 35, 35)
                                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                                        .addComponent(jDampingAlgCB, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                                        .addComponent(forceScaleTF))))
                                .addGap(10, 10, 10))
                );
        layout.setVerticalGroup(
                layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGroup(layout.createSequentialGroup()
                                .addGap(11, 11, 11)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                        .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 46, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 138, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addGap(9, 9, 9)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                        .addGroup(layout.createSequentialGroup()
                                                .addGap(3, 3, 3)
                                                .addComponent(jLabel3))
                                        .addComponent(forceScaleTF, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addGap(6, 6, 6)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                        .addGroup(layout.createSequentialGroup()
                                                .addGap(2, 2, 2)
                                                .addComponent(jLabel4))
                                        .addComponent(jDampingAlgCB, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addGap(6, 6, 6)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                        .addComponent(okButton)
                                        .addComponent(cancelButton)))
                );
    }// </editor-fold>//GEN-END:initComponents

    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        // please, DO NOT add any lines here, instead edit _cancelButtonActionPerformed()
        // it's a workaround, because Netbeans doesn't allow changing visibility of action handler :/
        _cancelButtonActionPerformed();
    }

    @Override
    protected void _cancelButtonActionPerformed()
    {
        dampingField = null;
        setVisible(false);
    }//GEN-LAST:event_cancelButtonActionPerformed

    private void okButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okButtonActionPerformed
        // please, DO NOT add any lines here, instead edit _okButtonActionPerformed()
        // it's a workaround, because Netbeans doesn't allow changing visibility of action handler :/
        _okButtonActionPerformed();
    }//GEN-LAST:event_okButtonActionPerformed

    private void forceScaleTFaddButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_forceScaleTFaddButtonActionPerformed
        // please, DO NOT add any lines here, instead edit _okButtonActionPerformed()
        // it's a workaround, because Netbeans doesn't allow changing visibility of action handler :/
        _okButtonActionPerformed();
    }//GEN-LAST:event_forceScaleTFaddButtonActionPerformed

    @Override
    protected void _okButtonActionPerformed()
    {
        RegularFld_DA data = (RegularFld_DA) dataCB.getSelectedValue();
        if (data == null) {
            JOptionPane.showMessageDialog(this, "Please select a component from the list.", "No data was selected", JOptionPane.INFORMATION_MESSAGE);
        } else {
            try {
                float forceScale = Float.parseFloat(forceScaleTF.getText());

                if (forceScale < 0)
                    throw new NegativeScaleException();

                dampingField.setData((Algorithm) jDampingAlgCB.getSelectedItem(),
                                     dataCB.getSelectedIndex(), data.fld, data.da,
                                     forceScale);
                setVisible(false);
            } catch (java.lang.NumberFormatException ex) {
                // wrong number for forceScale
                JOptionPane.showMessageDialog(this, "This is not a number", "Error", JOptionPane.ERROR_MESSAGE);
                forceScaleTF.requestFocus();
                forceScaleTF.selectAll();
            } catch (NegativeScaleException ex) {
                JOptionPane.showMessageDialog(this, "Scale must be non-negative", "Error", JOptionPane.ERROR_MESSAGE);
                forceScaleTF.requestFocus();
                forceScaleTF.selectAll();
            }
        }
    }

    @Override
    public IForce getForce()
    {
        return dampingField;
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton cancelButton;
    private javax.swing.JList dataCB;
    private javax.swing.JTextField forceScaleTF;
    private javax.swing.JComboBox jDampingAlgCB;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JButton okButton;

    // End of variables declaration//GEN-END:variables
    private ComboBoxModel createDampingAlgCBModel()
    {
        return new DefaultComboBoxModel(Algorithm.values());
    }
}
// revised.
